searchNodes=[{"doc":"A Top like implementation for Elixir Applications.Usage# Start with default options ex&gt; Etop.start() # Temporarily pause/stop ex&gt; Etop.pause() # Restart when paused ex&gt; Etop.start # Start logging to an exs file ex&gt; Etop.start file: &quot;/tmp/etop.exs&quot; # Load the current exs file ex&gt; data = Etop.load # Start then change number of processes and interval between collecting results ex&gt; Etop.start ex&gt; Etop.set_opts nprocs: 15, interval: 15_000 # or ex&gt; Etop.start ex&gt; Etop.pause ex&gt; Etop.start nprocs: 15, interval: 15_000 # Stop Etop, killing its GenServer ex&gt; Etop.stopConfigurationfile - Save the output to a file.format - the output file format. Values [:text, :exs]interval (5000) - the time (ms) between each runnprocs (10) - the number of processes to listsort (reds_diff) - the field to sort the process list. Values [:memory, :msgq, :reds, :reds_diff, :status, :default]","ref":"Etop.html","title":"Etop","type":"module"},{"doc":"Add a new monitor.Adds the given monitor to any existing monitors.Examplesiex&gt; Etop.start() iex&gt; callback = &amp;{&amp;1, &amp;2} iex&gt; Etop.monitor(:summary, [:load, :sys], 10.0, callback) iex&gt; Etop.add_monitor(:process, :reductions, 1000, callback) iex&gt; Etop.monitors() == ...&gt; [ ...&gt; {:process, :reductions, 1000, callback}, ...&gt; {:summary, [:load, :sys], 10.0, callback} ...&gt; ] true","ref":"Etop.html#add_monitor/4","title":"Etop.add_monitor/4","type":"function"},{"doc":"Add a new monitor to an Etop state map.","ref":"Etop.html#add_monitor/5","title":"Etop.add_monitor/5","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Etop.html#child_spec/1","title":"Etop.child_spec/1","type":"function"},{"doc":"Restart Etop if its halted.","ref":"Etop.html#continue/1","title":"Etop.continue/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Etop.html#init/1","title":"Etop.init/1","type":"function"},{"doc":"Load the current exs log file.","ref":"Etop.html#load/0","title":"Etop.load/0","type":"function"},{"doc":"Load the given .exs file.","ref":"Etop.html#load/1","title":"Etop.load/1","type":"function"},{"doc":"Set a monitor.Replaces any existing monitors with the given monitor.Examplesiex&gt; Etop.start() iex&gt; callback = &amp;{&amp;1, &amp;2} iex&gt; Etop.monitor(:summary, [:load, :sys], 10.0, callback) iex&gt; Etop.monitors() == [{:summary, [:load, :sys], 10.0, callback}] true","ref":"Etop.html#monitor/4","title":"Etop.monitor/4","type":"function"},{"doc":"","ref":"Etop.html#monitor/5","title":"Etop.monitor/5","type":"function"},{"doc":"Get the current monitors.Examplesiex&gt; Etop.start() iex&gt; callback = &amp;{&amp;1, &amp;2} iex&gt; Etop.monitor(:summary, [:load, :sys], 10.0, callback) iex&gt; Etop.monitors() == [{:summary, [:load, :sys], 10.0, callback}] true","ref":"Etop.html#monitors/0","title":"Etop.monitors/0","type":"function"},{"doc":"Pause a running Etop session.","ref":"Etop.html#pause/0","title":"Etop.pause/0","type":"function"},{"doc":"Remove a monitor.Examplesiex&gt; Etop.start() iex&gt; Etop.monitor(:summary, [:load, :total], 10.0, &amp;IO.inspect({&amp;1, &amp;2})) iex&gt; response = Etop.remove_monitor(:summary, [:load, :total], 10.0) iex&gt; {response, Etop.monitors()} {:ok, []}","ref":"Etop.html#remove_monitor/3","title":"Etop.remove_monitor/3","type":"function"},{"doc":"Remove all monitors.Examplesiex&gt; Etop.start() iex&gt; Etop.monitor(:summary, [:load, :total], 10.0, &amp;IO.inspect({&amp;1, &amp;2})) iex&gt; Etop.remove_monitors() iex&gt; Etop.monitors() []","ref":"Etop.html#remove_monitors/0","title":"Etop.remove_monitors/0","type":"function"},{"doc":"Enable or disable reporting.Disabling reporting stops reporting printing or logging reports but keeps the Etop collecting data. This option can be used with a monitor to toggle logging when a threshold is reached.Examplesiex&gt; Etop.start() iex&gt; Etop.reporting(false) :ok iex&gt; Etop.start() iex&gt; enable_callback = fn _, _ -&gt; Etop.reporting(true) end iex&gt; disable_callback = fn _, value -&gt; ...&gt; if value &lt; 40.0, do: Etop.reporting(false) ...&gt; end iex&gt; Etop.monitor(:summary, [:load, :total], 50.0, enable_callback) iex&gt; Etop.add_monitor(:summary, [:load, :total], 40.0, disable_callback) :ok","ref":"Etop.html#reporting/1","title":"Etop.reporting/1","type":"function"},{"doc":"","ref":"Etop.html#sanitize_info_result/1","title":"Etop.sanitize_info_result/1","type":"function"},{"doc":"","ref":"Etop.html#sanitize_stats/2","title":"Etop.sanitize_stats/2","type":"function"},{"doc":"Set Etop settings","ref":"Etop.html#set_opts/1","title":"Etop.set_opts/1","type":"function"},{"doc":"Start Etop Reporting.","ref":"Etop.html#start/1","title":"Etop.start/1","type":"function"},{"doc":"","ref":"Etop.html#statistics/1","title":"Etop.statistics/1","type":"function"},{"doc":"Get the status of the server","ref":"Etop.html#status/0","title":"Etop.status/0","type":"function"},{"doc":"","ref":"Etop.html#status!/0","title":"Etop.status!/0","type":"function"},{"doc":"Stop Etop Reporting.","ref":"Etop.html#stop/0","title":"Etop.stop/0","type":"function"},{"doc":"","ref":"Etop.html#t:monitor/0","title":"Etop.monitor/0","type":"type"},{"doc":"","ref":"Etop.html#t:monitor_callback/0","title":"Etop.monitor_callback/0","type":"type"},{"doc":"","ref":"Etop.html#t:monitor_fields/0","title":"Etop.monitor_fields/0","type":"type"},{"doc":"","ref":"Etop.html#t:monitor_type/0","title":"Etop.monitor_type/0","type":"type"},{"doc":"","ref":"Etop.html#t:monitors/0","title":"Etop.monitors/0","type":"type"},{"doc":"Create ASCII charts.Examplesiex&gt; data = for i &lt;- 1..30, do: i * 2 + :rand.uniform(4) - 2 iex&gt; labels = for {_, i} &lt;- Enum.with_index(data), do: &quot;Label \#{i}&quot; iex&gt; Etop.Chart.puts(data, labels: labels, title: &quot;Test Plot&quot;) Test Plot --------- 64 | * 60 | * 56 | * * 52 | * * * 48 | * 44 | * * 40 | * 36 | * * * * 32 | * 28 | * * 24 | * * 20 | * * 16 | * * 12 | * * 8 | * * * 4 | * 0 | +-------------------+-------------------+-------------------+-- Label 10 Label 20","ref":"Etop.Chart.html","title":"Etop.Chart","type":"module"},{"doc":"Write a chart of the given data to the console.Creates a plot of some time scale data with the following features:plot titleconfigurable chart height and widthperforms y axis down scaling to fit to the given widthperforms x axis down-scaling by taking the max of values in the scaling groupPerforms y axis lower bound truncating (0, min..max)x scale label prefixoption x axis labels (defaults to the series number if not provided)Optionsheight (20 default) - the height of the y axiswidth (100) - the width of the x axisy_label_postfix (&quot;&quot;) - the appended y axis labeltitle (nil) - Sting printed at the top of the chartlabels (nil) - List of x-axis labelsempty_char (0x20 - space) - the character for an empty charplot_char (?*) - the character for a plot pointExamplesiex&gt; data = Enum.to_list(1..20) iex&gt; labels = for i &lt;- data, do: &quot;Label \#{i}&quot; iex&gt; Etop.Chart.puts(data, labels: label)","ref":"Etop.Chart.html#generate/2","title":"Etop.Chart.generate/2","type":"function"},{"doc":"Generate and print a chart.Calls generate/2 and prints the result.See Etop.Chart.generate/2 for more information.","ref":"Etop.Chart.html#puts/2","title":"Etop.Chart.puts/2","type":"function"},{"doc":"Helpers for Etop.","ref":"Etop.Reader.html","title":"Etop.Reader","type":"module"},{"doc":"","ref":"Etop.Reader.html#check_monitor/2","title":"Etop.Reader.check_monitor/2","type":"function"},{"doc":"Get the number of CPU Cores.","ref":"Etop.Reader.html#core_count/0","title":"Etop.Reader.core_count/0","type":"function"},{"doc":"","ref":"Etop.Reader.html#get_stats/1","title":"Etop.Reader.get_stats/1","type":"function"},{"doc":"Handle the timer timeout.Collect and report the Top information.","ref":"Etop.Reader.html#handle_collect/2","title":"Etop.Reader.handle_collect/2","type":"function"},{"doc":"","ref":"Etop.Reader.html#monitor_msgq_callback/2","title":"Etop.Reader.monitor_msgq_callback/2","type":"function"},{"doc":"Fetch the initial CPU information.Gets the os_pid and core count.","ref":"Etop.Reader.html#remote_cpu_info/1","title":"Etop.Reader.remote_cpu_info/1","type":"function"},{"doc":"Fetch the top stats from either a current node or a remote node.Gets the following information and sends {:result, info_map} to the calling process:%{ procs: List of Process.info(pid) with memory stats added, nprocs: total process count, memory: overall memory information, runq: length of the run queue, util2: contents of &quot;/proc/&lt;os-pid&gt;/stat&quot;, }NOTE: remote nodes are not working.","ref":"Etop.Reader.html#remote_stats/1","title":"Etop.Reader.remote_stats/1","type":"function"},{"doc":"Etop Reporting Helpers.A set of functions to use to parse and process Etop results.Example output=========================================================================================================================== nonode@nohost 08:22:56 Load: cpu 2.9% Memory: total 42812208 binary 197472 procs 92 processes 23093664 code 10223211 runq 0 atom 512625 ets 791672 Pid Name or Initial Func Percent Reds Memory MssQ State Current Function --------------------------------------------------------------------------------------------------------------------------- &lt;0.9.0&gt; :erlang.apply/2 47.66 901851 284652 0 waiting :erl_prim_loader.loop/3 &lt;0.49.0&gt; :erlang.apply/2 12.57 237834 163492 0 waiting :code_server.loop/1 &lt;0.43.0&gt; :application_controller.start/1 8.13 153862 264396 0 waiting :gen_server.loop/7 &lt;0.1.0&gt; :erts_code_purger.start/0 7.44 140798 25848 0 waiting :erts_code_purger.wait_for_request/0 &lt;0.2.0&gt; :erts_literal_area_collector.start/ 7.11 134526 2688 0 waiting :erts_literal_area_collector.msg_loop/4 &lt;0.57.0&gt; :file_server.init/1 6.18 116917 426596 0 waiting :gen_server.loop/7 &lt;0.64.0&gt; :group.server/3 3.46 65443 10784016 0 waiting :group.more_data/6 &lt;0.79.0&gt; :disk_log.init/2 1.85 34950 197252 0 waiting :disk_log.loop/1 &lt;0.228.0&gt; Etop.init/1 1.77 33584 6781840 0 running Process.info/1 &lt;0.3.0&gt; :erts_dirty_process_signal_handler. 1.26 23850 2688 0 waiting :erts_dirty_process_signal_handler.msg_loop/0 ===========================================================================================================================","ref":"Etop.Report.html","title":"Etop.Report","type":"module"},{"doc":"Get the column width of the given column number.","ref":"Etop.Report.html#column_width/1","title":"Etop.Report.column_width/1","type":"function"},{"doc":"Create a report of the given processes list, and summary stats.","ref":"Etop.Report.html#create_report/3","title":"Etop.Report.create_report/3","type":"function"},{"doc":"Get the data loaded by compiling the output exs file.","ref":"Etop.Report.html#get/0","title":"Etop.Report.get/0","type":"function"},{"doc":"Helper to create and output the report.Output options:print to current leadersave text format to filesave executable format to exs file","ref":"Etop.Report.html#handle_report/1","title":"Etop.Report.handle_report/1","type":"function"},{"doc":"Map the given list to the given extract fields.Examplesiex&gt; Etop.Report.list([%{a: %{x: 1}, b: 2}, %{a: %{x: 2}, b: 3}], [:a, :x]) [1, 2]","ref":"Etop.Report.html#list/2","title":"Etop.Report.list/2","type":"function"},{"doc":"Map the given list.Examplesiex&gt; data = [%{summary: %{a: %{x: 1}, b: 2}}, %{summary: %{a: %{x: 2}, b: 3}}] iex&gt; Etop.Report.list(data, :a, :x) [1, 2]","ref":"Etop.Report.html#list/3","title":"Etop.Report.list/3","type":"function"},{"doc":"List the cpu usage values.Examplesiex&gt; data = [%{summary: %{load: %{cpu: 1}}}, %{summary: %{load: %{cpu: 2}}}] iex&gt; Etop.Report.list_cpu(data) [1, 2]","ref":"Etop.Report.html#list_cpu/1","title":"Etop.Report.list_cpu/1","type":"function"},{"doc":"List the memory usage fields.Examplesiex&gt; data = [ ...&gt; %{summary: %{memory: %{total: 2, user: 1}}}, ...&gt; %{summary: %{memory: %{total: 4, user: 3}}}] iex&gt; Etop.Report.list_memory(data) [2, 4] iex&gt; data = [ ...&gt; %{summary: %{memory: %{total: 2, user: 1}}}, ...&gt; %{summary: %{memory: %{total: 4, user: 3}}}] iex&gt; Etop.Report.list_memory(data, :user) [1, 3]","ref":"Etop.Report.html#list_memory/2","title":"Etop.Report.list_memory/2","type":"function"},{"doc":"Load the given exs file.","ref":"Etop.Report.html#load/1","title":"Etop.Report.load/1","type":"function"},{"doc":"Get the entry with the max load.Gets the entries from Etop.Agent","ref":"Etop.Report.html#max/0","title":"Etop.Report.max/0","type":"function"},{"doc":"Get the entry with the max load from the given entries list.","ref":"Etop.Report.html#max/1","title":"Etop.Report.max/1","type":"function"},{"doc":"Print a chart of the given data.","ref":"Etop.Report.html#plot/2","title":"Etop.Report.plot/2","type":"function"},{"doc":"Print a chart of the cpu usage.","ref":"Etop.Report.html#plot_cpu/2","title":"Etop.Report.plot_cpu/2","type":"function"},{"doc":"Print a chart of the memory usage.","ref":"Etop.Report.html#plot_memory/2","title":"Etop.Report.plot_memory/2","type":"function"},{"doc":"Print a report with default options.Prints a single top entry or a list of top entries to leader or the given file.See Etop.Report.print/3 for more details.","ref":"Etop.Report.html#print/1","title":"Etop.Report.print/1","type":"function"},{"doc":"Print a report with defaults.See Etop.Report.print/3 for more details.","ref":"Etop.Report.html#print/2","title":"Etop.Report.print/2","type":"function"},{"doc":"Print a report.Prints a single top entry or a list of top entries to leader or the given file.Options:sort - one of [:memory, :msgq, :reds, :reds_diff, :state, :fun, :name, :percent, :pid]","ref":"Etop.Report.html#print/3","title":"Etop.Report.print/3","type":"function"},{"doc":"Save a report in Elixir terms format.Saves the report so that it can be later loaded and analyzed.","ref":"Etop.Report.html#save_exs_report/2","title":"Etop.Report.save_exs_report/2","type":"function"},{"doc":"Get the top n entries.","ref":"Etop.Report.html#top/2","title":"Etop.Report.top/2","type":"function"},{"doc":"Utility helpers for Etop.","ref":"Etop.Utils.html","title":"Etop.Utils","type":"module"},{"doc":"Center the given string in the given length.Return a string of length &gt;= the given length with the given string centered.The returned string is padded (leading and trailing) with the given padding (default &quot; &quot;)Examplesiex&gt; Etop.Utils.center(&quot;Test&quot;, 8) &quot; Test &quot; iex&gt; Etop.Utils.center(&#39;Test&#39;, 7, &quot;-&quot;) &quot;-Test--&quot;","ref":"Etop.Utils.html#center/3","title":"Etop.Utils.center/3","type":"function"},{"doc":"Returns the server's local naive datetime with the microsecond field truncated to the given precision (:microsecond, :millisecond or :second).Argumentsdatetime (default utc_now)precision (default :second)Examplesiex&gt; datetime = Etop.Utils.local_time() iex&gt; datetime.year &gt;= 2020 true iex&gt; datetime = Etop.Utils.local_time(:millisecond) iex&gt; elem(datetime.microsecond, 1) 3 iex&gt; datetime = NaiveDateTime.utc_now() iex&gt; expected = NaiveDateTime.add(datetime, Etop.Utils.timezone_offset()) iex&gt; Etop.Utils.local_time(datetime) == %{expected | microsecond: {0, 0}} true iex&gt; datetime = NaiveDateTime.utc_now() iex&gt; expected = NaiveDateTime.add(datetime, Etop.Utils.timezone_offset()) iex&gt; Etop.Utils.local_time(datetime, :microsecond) == expected true","ref":"Etop.Utils.html#local_time/2","title":"Etop.Utils.local_time/2","type":"function"},{"doc":"Pad (leading) the given string with spaces for the given length.Examplesiex&gt; Etop.Utils.pad(&quot;Test&quot;, 8) &quot; Test&quot; iex&gt; Etop.Utils.pad(&quot;Test&quot;, 2) &quot;Test&quot; iex&gt; Etop.Utils.pad(100, 4, &quot;0&quot;) &quot;0100&quot;","ref":"Etop.Utils.html#pad/3","title":"Etop.Utils.pad/3","type":"function"},{"doc":"Pad (trailing) the given string with spaces for the given length.Examplesiex&gt; Etop.Utils.pad_t(&quot;Test&quot;, 8) &quot;Test &quot; iex&gt; Etop.Utils.pad_t(&quot;Test&quot;, 2) &quot;Test&quot; iex&gt; Etop.Utils.pad_t(10.1, 5, &quot;0&quot;) &quot;10.10&quot;","ref":"Etop.Utils.html#pad_t/3","title":"Etop.Utils.pad_t/3","type":"function"},{"doc":"Configurable sort.Argumentslist - the enumerable to be sorted.field (:reductions_diff) - the field to be sorted on.field_fn (fn field -&gt; &amp;elem(&amp;1, 1)[field] end) - function to get the field.sorter_fn (&amp;&gt;/2) -&gt; Sort comparator (default descending)Examplesiex&gt; data = [one: %{a: 3, b: 2}, two: %{a: 1, b: 3}] iex&gt; Etop.Utils.sort(data, :b) [two: %{a: 1, b: 3}, one: %{a: 3, b: 2}] iex&gt; data = [one: %{a: 3, b: 2}, two: %{a: 1, b: 3}] iex&gt; Etop.Utils.sort(data, :a, sorter: &amp;&lt;=/2) [two: %{a: 1, b: 3}, one: %{a: 3, b: 2}] iex&gt; data = [%{a: 1, b: 2}, %{a: 2, b: 3}] iex&gt; Etop.Utils.sort(data, :a, mapper: &amp; &amp;1[:a]) [%{a: 2, b: 3}, %{a: 1, b: 2}] iex&gt; data = [x: %{a: 1, b: 1}, y: %{a: 1, b: 2}, z: %{a: 2, b: 0}] iex&gt; Etop.Utils.sort(data, :a, secondary: :b) [z: %{a: 2, b: 0}, y: %{a: 1, b: 2}, x: %{a: 1, b: 1}]","ref":"Etop.Utils.html#sort/3","title":"Etop.Utils.sort/3","type":"function"},{"doc":"Get the server's timezone offset in seconds.","ref":"Etop.Utils.html#timezone_offset/0","title":"Etop.Utils.timezone_offset/0","type":"function"},{"doc":"Etop - A Unix like top library for Elixir ApplicationsA Unix top like functionality for Elixir Applications.","ref":"readme.html","title":"Etop - A Unix like top library for Elixir Applications","type":"extras"},{"doc":"Configurable number of listed processesConfigurable intervalStart, Stop, Pause, and change configuration optionsRemote Node (Not working yet)Print results toIO leadertext fileexs fileexs file logging allow loading and post processing resultsascii charting of resultsExample output=========================================================================================================================== nonode@nohost 08:22:56 Load: cpu 2.9% Memory: total 42812208 binary 197472 procs 92 processes 23093664 code 10223211 runq 0 atom 512625 ets 791672 Pid Name or Initial Func Percent Reds Memory MssQ State Current Function --------------------------------------------------------------------------------------------------------------------------- &lt;0.9.0&gt; :erlang.apply/2 47.66 901851 284652 0 waiting :erl_prim_loader.loop/3 &lt;0.49.0&gt; :erlang.apply/2 12.57 237834 163492 0 waiting :code_server.loop/1 &lt;0.43.0&gt; :application_controller.start/1 8.13 153862 264396 0 waiting :gen_server.loop/7 &lt;0.1.0&gt; :erts_code_purger.start/0 7.44 140798 25848 0 waiting :erts_code_purger.wait_for_request/0 &lt;0.2.0&gt; :erts_literal_area_collector.start/ 7.11 134526 2688 0 waiting :erts_literal_area_collector.msg_loop/4 &lt;0.57.0&gt; :file_server.init/1 6.18 116917 426596 0 waiting :gen_server.loop/7 &lt;0.64.0&gt; :group.server/3 3.46 65443 10784016 0 waiting :group.more_data/6 &lt;0.79.0&gt; :disk_log.init/2 1.85 34950 197252 0 waiting :disk_log.loop/1 &lt;0.228.0&gt; Etop.init/1 1.77 33584 6781840 0 running Process.info/1 &lt;0.3.0&gt; :erts_dirty_process_signal_handler. 1.26 23850 2688 0 waiting :erts_dirty_process_signal_handler.msg_loop/0 ===========================================================================================================================GraphsPlot CPU usage from a .exs log file.iex(1)&gt; Etop.start(file: &quot;/tmp/etop.exs&quot;, interval: 2000) iex(2)&gt; Etop.load() |&gt; Etop.Report.plot_cpu() CPU Utilization --------------- 10% | 9% | * 8% | * * 7% | * 6% | * 5% | 4% | * 3% | * 2% | * * * * * * 1% | * * * * * * * * * * * 0% | +-------------------+-------------------+---------- 08:36:31 08:36:52Plot memory usage from a .exs log file.iex(1)&gt; Etop.start(file: &quot;/tmp/etop.exs&quot;, interval: 2000) iex(2)&gt; Etop.load |&gt; Etop.Report.plot_memory(height: 15) Memory Usage ------------ 162MB | * 153MB | * 144MB | * * * * 135MB | * * * * * * 126MB | * * * * 117MB | * 108MB | 99MB | 90MB | 81MB | * 72MB | * * 63MB | * * * 54MB | 45MB | 36MB | * 0MB | +-------------------+-------------------+----------","ref":"readme.html#features","title":"Etop - A Unix like top library for Elixir Applications - Features","type":"extras"},{"doc":"There are 2 reasons why I created this libraryOur default production installations don't have etop or observer includedThis version supports loading and post processing log files","ref":"readme.html#why-not-use-erlang-s-etop-library","title":"Etop - A Unix like top library for Elixir Applications - Why not use erlang's :etop library?","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding etop to your list of dependencies in mix.exs:def deps do [ {:etop, &quot;~&gt; 0.5&quot;} ] endDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/etop.","ref":"readme.html#installation","title":"Etop - A Unix like top library for Elixir Applications - Installation","type":"extras"},{"doc":"Etop is Copyright (c) 2020-2021 E-MetroTelThe source code is released under the MIT License.Check LICENSE for more information.","ref":"readme.html#license","title":"Etop - A Unix like top library for Elixir Applications - License","type":"extras"},{"doc":"The MIT License (MIT)Copyright (c) 2020 E-MetroTelPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]